<?php
function sayfagetir($url) {
    $ch = curl_init();
    curl_setopt($ch, CURLOPT_HEADER, 0);
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1); //Set curl to return the data instead of printing it to the browser.
    curl_setopt($ch, CURLOPT_URL, $url);
    $data = curl_exec($ch);
    curl_close($ch);
    return $data;
}

function linkkes($uri = ''){
	$uri = trim(eregi_replace('http://', '', $uri));
	$uri = trim(eregi_replace('http', '', $uri));
	return $uri;
}

//--> for google pagerank
/*
* Genearate a hash for a url
*/
function StrToNum($Str, $Check, $Magic)
{
    $Int32Unit = 4294967296;  // 2^32

    $length = strlen($Str);
    for ($i = 0; $i < $length; $i++) {
        $Check *= $Magic;     
        //If the float is beyond the boundaries of integer (usually +/- 2.15e+9 = 2^31),
        //  the result of converting to integer is undefined
        //  refer to http://www.php.net/manual/en/language.types.integer.php
        if ($Check >= $Int32Unit) {
            $Check = ($Check - $Int32Unit * (int) ($Check / $Int32Unit));
            //if the check less than -2^31
            $Check = ($Check < -2147483648) ? ($Check + $Int32Unit) : $Check;
        }
        $Check += ord($Str{$i});
    }
    return $Check;
}

function HashURL($String)
{
    $Check1 = StrToNum($String, 0x1505, 0x21);
    $Check2 = StrToNum($String, 0, 0x1003F);

    $Check1 >>= 2;     
    $Check1 = (($Check1 >> 4) & 0x3FFFFC0 ) | ($Check1 & 0x3F);
    $Check1 = (($Check1 >> 4) & 0x3FFC00 ) | ($Check1 & 0x3FF);
    $Check1 = (($Check1 >> 4) & 0x3C000 ) | ($Check1 & 0x3FFF);   
   
    $T1 = (((($Check1 & 0x3C0) << 4) | ($Check1 & 0x3C)) <<2 ) | ($Check2 & 0xF0F );
    $T2 = (((($Check1 & 0xFFFFC000) << 4) | ($Check1 & 0x3C00)) << 0xA) | ($Check2 & 0xF0F0000 );
   
    return ($T1 | $T2);
}

//--> for google pagerank
/*
* genearate a checksum for the hash string
*/
function CheckHash($Hashnum)
{
    $CheckByte = 0;
    $Flag = 0;

    $HashStr = sprintf('%u', $Hashnum) ;
    $length = strlen($HashStr);
   
    for ($i = $length - 1;  $i >= 0;  $i --) {
        $Re = $HashStr{$i};
        if (1 === ($Flag % 2)) {             
            $Re += $Re;     
            $Re = (int)($Re / 10) + ($Re % 10);
        }
        $CheckByte += $Re;
        $Flag ++;   
    }

    $CheckByte %= 10;
    if (0 !== $CheckByte) {
        $CheckByte = 10 - $CheckByte;
        if (1 === ($Flag % 2) ) {
            if (1 === ($CheckByte % 2)) {
                $CheckByte += 9;
            }
            $CheckByte >>= 1;
        }
    }

    return '7'.$CheckByte.$HashStr;
}

// Check Google Pagerank
function googlePR($url = ''){
	$gpr = "http://toolbarqueries.google.com/search?client=navclient-auto&ch=".CheckHash(HashURL($url))."&features=Rank&q=info:".$url;
	$getit = @file_get_contents($gpr);
	$pr = substr($getit, 9);
	return $pr;
}


// Google Backlink Kontrolü
function googleBacklink($url = ''){
	$url = linkkes($url);
	$blink = "http://www.google.com.tr/search?q=link:".$url."&filter=0";
	$gbl = sayfagetir($blink);
	$bul = @explode("<b>", $gbl);
	$bul1 = @explode("</b>", $bul[3]);
	$backlink = $bul1[0];
	return $backlink;
}


// Google Indexlenmiş Sayfa Sayısı
function googleIndexSayfa($url = ''){
	$url = linkkes($url);
	$gindex = "http://www.google.com/search?q=site:".$url;
	$gindexbul = sayfagetir($gindex);
	$bul = @explode("<b>", $gindexbul);
	$bul1 = @explode("</b>", $bul[4]);
	$googleindex = $bul1[0];
	return $googleindex;
}


// Google En Son Ne Zaman Geldi ?
function googleBotZiyareti($url = ''){
	$url = linkkes($url);
	$gbot = "http://74.125.47.132/search?hl=tr&q=cache:".$url;
	$gbotbul = sayfagetir($gbot);
	$bul = @explode("sayfan", $gbotbul);
	$bul1 = @explode(" GMT", $bul[1]);
	$googlebot = substr($bul1[0], 3);
	return $googlebot;
}


// Check Alexa Rank FIXED
function alexaRank($url = ''){
	$alexa = "http://www.alexa.com/siteinfo/".$url;
	$getit = @file_get_contents($alexa);
	$falx = @explode('<img src="/images/icons/globe-sm.jpg" alt="Global" style="margin-bottom:-2px;"/>', $getit);
	$ealx = @explode("</div>", $falx[1]);
	$rank = $ealx[0];
	return $rank;
}



// Yahoo Backlink Sayısı
function yahooBacklink($url = ''){
	$url = linkkes($url);
	$yback = "http://siteexplorer.search.yahoo.com/advsearch?p=http://".$url."&bwm=i&bwmo=d&bwmf=u";
	$ybbul = sayfagetir($yback);
	$bul = @explode("Inlinks (", $ybbul);
	$bul1 = @explode(")", $bul[1]);
	$ybacklink = $bul1[0];
	return $ybacklink;
}


// Yahoo Indexlenmiş Sayfa Sayısı
function yahooIndexSayfa($url = ''){
	$url = linkkes($url);
	$yindex = "http://siteexplorer.search.yahoo.com/advsearch?p=http://".$url;
	$yindexbul = sayfagetir($yindex);
	$bul = @explode("Pages (", $yindexbul);
	$bul1 = @explode(")", $bul[1]);
	$yahooindex = $bul1[0];
	return $yahooindex;
}


// DMOZ Kayıt Kontrol
function dmozKontrol($url = ''){
	$url = linkkes($url);
	$url = trim(eregi_replace('www.', '', $url));
	$dmoz = "http://search.dmoz.org/cgi-bin/search?search=".$url;
	$dmozbul = sayfagetir($dmoz);
	$kontrol = strpos($dmozbul, 'match');
	if($kontrol == 0) {	$sonuc = "No"; }
	else { $sonuc = "Var"; }
	return $sonuc;
}


// DEL.ICIO.US Link Sayısı
function delicous($url = ''){
	$url = linkkes($url);
	$dlc = "http://delicious.com/url/check?url=http://".$url;
	$dlcbul = @file_get_contents($dlc);
	$kontrol = strpos($dlcbul, 'savers');
	if($kontrol == 0) {	$delicious = "0"; }	else {
		$bul = @explode("savers", $dlcbul);
		$bul1 = @explode("<", $bul[1]);
		$delicious = substr($bul1[0], 3);
	}
	return $delicious;
}


// Link mi Değil mi ?
function is_valid_url($url = '') { 
	
	// SCHEME
	$urlregex = "^(https?|ftp)\:\/\/";

	// USER AND PASS (optional)
	$urlregex .= "([a-z0-9+!*(),;?&=\$_.-]+(\:[a-z0-9+!*(),;?&=\$_.-]+)?@)?";

	// HOSTNAME OR IP
	//$urlregex .= "[a-z0-9+\$_-]+(\.[a-z0-9+\$_-]+)*";  // http://x = allowed (ex. http://localhost, http://routerlogin)
	$urlregex .= "[a-z0-9+\$_-]+(\.[a-z0-9+\$_-]+)+";  // http://x.x = minimum
	//$urlregex .= "([a-z0-9+\$_-]+\.)*[a-z0-9+\$_-]{2,3}";  // http://x.xx(x) = minimum
	//use only one of the above

	// PORT (optional)
	$urlregex .= "(\:[0-9]{2,5})?";
	// PATH  (optional)
	$urlregex .= "(\/([a-z0-9+\$_-]\.?)+)*\/?";
	// GET Query (optional)
	$urlregex .= "(\?[a-z+&\$_.-][a-z0-9;:@/&%=+\$_.-]*)?";
	// ANCHOR (optional)
	$urlregex .= "(#[a-z_.-][a-z0-9+\$_.-]*)?\$";

	if (eregi($urlregex, $url)) { return true; } else { return false; }
}
?>